using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using IOWarrior;

using System.Diagnostics;
//using System.Timers;

namespace LCDExample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox tbLine1;
		private System.Windows.Forms.TextBox tbLine2;
		private System.Windows.Forms.TextBox tbLine3;
		private System.Windows.Forms.TextBox tbLine4;
		private System.Windows.Forms.NotifyIcon notifyIcon1;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.Button alignLeftBtn;
		private System.Windows.Forms.Button alignCenterBtn;
		private System.Windows.Forms.Button alignRightBtn;
		private System.Windows.Forms.LinkLabel linkLabel1;
		private System.Windows.Forms.LinkLabel linkLabel2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.ListBox lbIRMessages;
		private System.Windows.Forms.Label labelProductId;
		private System.Windows.Forms.Label labelSerialNr;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.CheckBox cbUseIR;
		private System.Windows.Forms.CheckBox cbShowCursor;
		private System.Windows.Forms.CheckBox cbCursorBlinking;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cbCharAddress;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;

		// this is our 5x8 dot matrix
		private MyTextBox[][] dotMatrixTB;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.tbLine1 = new System.Windows.Forms.TextBox();
			this.tbLine2 = new System.Windows.Forms.TextBox();
			this.tbLine3 = new System.Windows.Forms.TextBox();
			this.tbLine4 = new System.Windows.Forms.TextBox();
			this.alignLeftBtn = new System.Windows.Forms.Button();
			this.alignCenterBtn = new System.Windows.Forms.Button();
			this.alignRightBtn = new System.Windows.Forms.Button();
			this.notifyIcon1 = new System.Windows.Forms.NotifyIcon(this.components);
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.linkLabel2 = new System.Windows.Forms.LinkLabel();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.button3 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.cbCursorBlinking = new System.Windows.Forms.CheckBox();
			this.cbShowCursor = new System.Windows.Forms.CheckBox();
			this.labelSerialNr = new System.Windows.Forms.Label();
			this.labelProductId = new System.Windows.Forms.Label();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.lbIRMessages = new System.Windows.Forms.ListBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.cbUseIR = new System.Windows.Forms.CheckBox();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.button1 = new System.Windows.Forms.Button();
			this.cbCharAddress = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.SuspendLayout();
			// 
			// tbLine1
			// 
			this.tbLine1.BackColor = System.Drawing.SystemColors.Window;
			this.tbLine1.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbLine1.Location = new System.Drawing.Point(24, 32);
			this.tbLine1.MaxLength = 100;
			this.tbLine1.Name = "tbLine1";
			this.tbLine1.Size = new System.Drawing.Size(168, 22);
			this.tbLine1.TabIndex = 1;
			this.tbLine1.Text = "";
			this.tbLine1.Enter += new System.EventHandler(this.TextBoxEnter);
			// 
			// tbLine2
			// 
			this.tbLine2.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbLine2.Location = new System.Drawing.Point(24, 56);
			this.tbLine2.MaxLength = 100;
			this.tbLine2.Name = "tbLine2";
			this.tbLine2.Size = new System.Drawing.Size(168, 22);
			this.tbLine2.TabIndex = 2;
			this.tbLine2.Text = "";
			this.tbLine2.Enter += new System.EventHandler(this.TextBoxEnter);
			// 
			// tbLine3
			// 
			this.tbLine3.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbLine3.Location = new System.Drawing.Point(24, 80);
			this.tbLine3.MaxLength = 100;
			this.tbLine3.Name = "tbLine3";
			this.tbLine3.Size = new System.Drawing.Size(168, 22);
			this.tbLine3.TabIndex = 3;
			this.tbLine3.Text = "";
			this.tbLine3.Enter += new System.EventHandler(this.TextBoxEnter);
			// 
			// tbLine4
			// 
			this.tbLine4.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbLine4.Location = new System.Drawing.Point(24, 104);
			this.tbLine4.MaxLength = 100;
			this.tbLine4.Name = "tbLine4";
			this.tbLine4.Size = new System.Drawing.Size(168, 22);
			this.tbLine4.TabIndex = 4;
			this.tbLine4.Text = "";
			this.tbLine4.Enter += new System.EventHandler(this.TextBoxEnter);
			// 
			// alignLeftBtn
			// 
			this.alignLeftBtn.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.alignLeftBtn.Location = new System.Drawing.Point(216, 32);
			this.alignLeftBtn.Name = "alignLeftBtn";
			this.alignLeftBtn.TabIndex = 5;
			this.alignLeftBtn.Text = "align left";
			this.alignLeftBtn.Click += new System.EventHandler(this.alignLeftBtn_Click);
			// 
			// alignCenterBtn
			// 
			this.alignCenterBtn.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.alignCenterBtn.Location = new System.Drawing.Point(216, 56);
			this.alignCenterBtn.Name = "alignCenterBtn";
			this.alignCenterBtn.TabIndex = 6;
			this.alignCenterBtn.Text = "align center";
			this.alignCenterBtn.Click += new System.EventHandler(this.alignCenterBtn_Click);
			// 
			// alignRightBtn
			// 
			this.alignRightBtn.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.alignRightBtn.Location = new System.Drawing.Point(216, 80);
			this.alignRightBtn.Name = "alignRightBtn";
			this.alignRightBtn.TabIndex = 7;
			this.alignRightBtn.Text = "align right";
			this.alignRightBtn.Click += new System.EventHandler(this.alignRightBtn_Click);
			// 
			// notifyIcon1
			// 
			this.notifyIcon1.ContextMenu = this.contextMenu1;
			this.notifyIcon1.Icon = ((System.Drawing.Icon)(resources.GetObject("notifyIcon1.Icon")));
			this.notifyIcon1.Text = "LCD Example with .NET and C#";
			this.notifyIcon1.DoubleClick += new System.EventHandler(this.notifyIcon1_DoubleClick);
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItem1,
																						 this.menuItem2,
																						 this.menuItem3});
			// 
			// menuItem1
			// 
			this.menuItem1.DefaultItem = true;
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "Restore";
			this.menuItem1.Click += new System.EventHandler(this.notifyIcon1_DoubleClick);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "-";
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 2;
			this.menuItem3.Text = "Close Application";
			this.menuItem3.Click += new System.EventHandler(this.QuitAll);
			// 
			// linkLabel1
			// 
			this.linkLabel1.Location = new System.Drawing.Point(200, 104);
			this.linkLabel1.Name = "linkLabel1";
			this.linkLabel1.Size = new System.Drawing.Size(100, 16);
			this.linkLabel1.TabIndex = 23;
			this.linkLabel1.TabStop = true;
			this.linkLabel1.Text = "clear current Line";
			this.linkLabel1.Click += new System.EventHandler(this.clrLineBtn_Click);
			// 
			// linkLabel2
			// 
			this.linkLabel2.Location = new System.Drawing.Point(16, 24);
			this.linkLabel2.Name = "linkLabel2";
			this.linkLabel2.Size = new System.Drawing.Size(100, 16);
			this.linkLabel2.TabIndex = 24;
			this.linkLabel2.TabStop = true;
			this.linkLabel2.Text = "clear LCD screen";
			this.linkLabel2.Click += new System.EventHandler(this.clrLcdBtn_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.linkLabel1});
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(304, 152);
			this.groupBox1.TabIndex = 25;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Lines";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					//this.button3, // just for debugging
																					//this.button2, // just for debugging
																					this.cbCursorBlinking,
																					this.cbShowCursor,
																					this.labelSerialNr,
																					this.labelProductId,
																					this.linkLabel2,
																					this.groupBox4});
			this.groupBox2.Location = new System.Drawing.Point(328, 8);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(264, 152);
			this.groupBox2.TabIndex = 26;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "General";
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(200, 24);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(48, 32);
			this.button3.TabIndex = 31;
			this.button3.Text = "button3";
//			this.button3.Click += new System.EventHandler(this.button3_Click); // for debugging
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(136, 16);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(48, 40);
			this.button2.TabIndex = 30;
			this.button2.Text = "button2";
//			this.button2.Click += new System.EventHandler(this.button2_Click); // for debugging
			// 
			// cbCursorBlinking
			// 
			this.cbCursorBlinking.Checked = true;
			this.cbCursorBlinking.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbCursorBlinking.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbCursorBlinking.Location = new System.Drawing.Point(16, 64);
			this.cbCursorBlinking.Name = "cbCursorBlinking";
			this.cbCursorBlinking.Size = new System.Drawing.Size(128, 24);
			this.cbCursorBlinking.TabIndex = 28;
			this.cbCursorBlinking.Text = "show blinking Cursor";
			this.cbCursorBlinking.CheckedChanged += new System.EventHandler(this.cbCursorsOptions_CheckedChanged);
			// 
			// cbShowCursor
			// 
			this.cbShowCursor.Checked = true;
			this.cbShowCursor.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbShowCursor.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbShowCursor.Location = new System.Drawing.Point(16, 40);
			this.cbShowCursor.Name = "cbShowCursor";
			this.cbShowCursor.TabIndex = 27;
			this.cbShowCursor.Text = "show Cursor";
			this.cbShowCursor.CheckedChanged += new System.EventHandler(this.cbCursorsOptions_CheckedChanged);
			// 
			// labelSerialNr
			// 
			this.labelSerialNr.Location = new System.Drawing.Point(16, 128);
			this.labelSerialNr.Name = "labelSerialNr";
			this.labelSerialNr.Size = new System.Drawing.Size(240, 16);
			this.labelSerialNr.TabIndex = 26;
			this.labelSerialNr.Text = "labelSerialNr";
			// 
			// labelProductId
			// 
			this.labelProductId.Location = new System.Drawing.Point(16, 112);
			this.labelProductId.Name = "labelProductId";
			this.labelProductId.Size = new System.Drawing.Size(240, 16);
			this.labelProductId.TabIndex = 25;
			this.labelProductId.Text = "labelProductId";
			// 
			// groupBox4
			// 
			this.groupBox4.Location = new System.Drawing.Point(16, 96);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(232, 3);
			this.groupBox4.TabIndex = 29;
			this.groupBox4.TabStop = false;
			// 
			// lbIRMessages
			// 
			this.lbIRMessages.Location = new System.Drawing.Point(8, 40);
			this.lbIRMessages.Name = "lbIRMessages";
			this.lbIRMessages.Size = new System.Drawing.Size(248, 160);
			this.lbIRMessages.TabIndex = 27;
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.lbIRMessages,
																					this.cbUseIR});
			this.groupBox3.Location = new System.Drawing.Point(328, 176);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(264, 216);
			this.groupBox3.TabIndex = 28;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "InfraRed";
			// 
			// cbUseIR
			// 
			this.cbUseIR.Checked = true;
			this.cbUseIR.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbUseIR.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbUseIR.Location = new System.Drawing.Point(16, 16);
			this.cbUseIR.Name = "cbUseIR";
			this.cbUseIR.TabIndex = 29;
			this.cbUseIR.Text = "enabled";
			this.cbUseIR.CheckedChanged += new System.EventHandler(this.cbUseIR_CheckedChanged);
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label3,
																					this.label2,
																					this.button1,
																					this.cbCharAddress,
																					this.label1});
			this.groupBox5.Location = new System.Drawing.Point(8, 176);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(304, 216);
			this.groupBox5.TabIndex = 29;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Special Characters (0..7)";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(128, 90);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(160, 56);
			this.label3.TabIndex = 4;
			this.label3.Text = "Yo can use {SP0} .. {SP7}  to write your special char .. for example:\nhello{SP0} " +
				"how are you?";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(17, 184);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(250, 24);
			this.label2.TabIndex = 3;
			this.label2.Text = "NOTE: the last line is reserved for the cursor";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(224, 48);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(48, 23);
			this.button1.TabIndex = 2;
			this.button1.Text = "write";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// cbCharAddress
			// 
			this.cbCharAddress.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbCharAddress.Items.AddRange(new object[] {
															   "SP0",
															   "SP1",
															   "SP2",
															   "SP3",
															   "SP4",
															   "SP5",
															   "SP6",
															   "SP7"});
			this.cbCharAddress.Location = new System.Drawing.Point(128, 48);
			this.cbCharAddress.Name = "cbCharAddress";
			this.cbCharAddress.Size = new System.Drawing.Size(88, 21);
			this.cbCharAddress.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(128, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(168, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "writes this character to address:";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 405);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.groupBox2,
																		  this.alignRightBtn,
																		  this.alignCenterBtn,
																		  this.alignLeftBtn,
																		  this.tbLine1,
																		  this.tbLine2,
																		  this.tbLine3,
																		  this.tbLine4,
																		  this.groupBox1,
																		  this.groupBox3,
																		  this.groupBox5});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "LCD Example with .NET and C#";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		private TextBox lastActiveTB = null;
		private IOWKit iow = null;

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		/// <summary>
		/// Event when the Tray Icon will be double clicked
		/// (Tray icon will only be visible when Application is minimized
		/// </summary>
		private void notifyIcon1_DoubleClick(object sender, System.EventArgs e)
		{
			this.Show();
			this.WindowState = FormWindowState.Normal;
			notifyIcon1.Visible = false;		
		}

		/// <summary>
		/// Event is called, when the Form will be resized
		/// (or in our case, minimized) ...
		/// When minimized, this function hides itself in the 
		/// taskbar and shows the tray icon
		/// </summary>
		private void Form1_Resize(object sender, System.EventArgs e)
		{
			if ( this.WindowState == FormWindowState.Minimized)
			{
				this.Hide();
				notifyIcon1.Visible = true;
			}		
		}

		private void InitDotMatrix()
		{
			this.dotMatrixTB = new MyTextBox[5][];

			for(int i = 0; i < 5; i++)
				this.dotMatrixTB[i] = new MyTextBox[8];

			for(int i = 0; i < 5; i++)
				for(int j = 0; j < 8; j++)
				{
					this.dotMatrixTB[i][j] = new MyTextBox();
					if(j == 7)
						this.dotMatrixTB[i][j].BackColor = System.Drawing.SystemColors.GrayText;
					else
						this.dotMatrixTB[i][j].BackColor = System.Drawing.SystemColors.Window;
					this.dotMatrixTB[i][j].Location = new System.Drawing.Point(20 + 17*i, 27 + j*18);
					this.dotMatrixTB[i][j].BorderStyle = BorderStyle.FixedSingle;
					this.dotMatrixTB[i][j].MaxLength = 1;
					this.dotMatrixTB[i][j].Name = "tbLine1";
					this.dotMatrixTB[i][j].Size = new System.Drawing.Size(18, 18);
					this.dotMatrixTB[i][j].TabIndex = 1;
					this.dotMatrixTB[i][j].Text = "";
					this.dotMatrixTB[i][j].Cursor = Cursors.Hand;
					this.dotMatrixTB[i][j].ReadOnly = true;
					this.dotMatrixTB[i][j].MouseDown += new MouseEventHandler(this.SelectBit);
					this.dotMatrixTB[i][j].CurrentColumn = i;
					this.dotMatrixTB[i][j].CurrentRow = j;
					this.groupBox5.Controls.Add( this.dotMatrixTB[i][j] );
				}
		}

		private void SelectBit(object sender, MouseEventArgs e)
		{
			MyTextBox activeTB = (MyTextBox)sender;
			activeTB.Selected = !activeTB.Selected;
			if( activeTB.Selected )
				activeTB.BackColor = Color.Black;
			else
			{
				if(activeTB.CurrentRow == 7) // last line
					activeTB.BackColor = SystemColors.GrayText;
				else
					activeTB.BackColor = SystemColors.Window;
			}
			activeTB.Focus();
		}

		/// <summary>
		/// Some Init stuff
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Form1_Load(object sender, System.EventArgs e)
		{

			// we draw the textboxes for the special character matrix dynamicly here
			InitDotMatrix();

			iow = new IOWKit();
			iow.Init(20, 4, true, true); // cursor and blinking		

			// setting some status info
			labelSerialNr.Text = "Serial Number: " + iow.SerialNumber;
			if( iow.ProductId == "1500")
				labelProductId.Text = "IOWarrior40 found (0x1500)";
			else if (iow.ProductId == "1501")
				labelProductId.Text = "IOWarrior24 found (0x1501)";
			else if (iow.ProductId == "0")
			{
				labelProductId.Text = "No IOWarrior found";    
				foreach (Control c in this.Controls)
					c.Enabled = false;
				MessageBox.Show( "Could Not find IOWarrior. Check if USB cable is connected.", null, MessageBoxButtons.OK, MessageBoxIcon.Warning );
			}
			else 
				labelProductId.Text = "unknown IOWarrior found (0x" + iow.ProductId + ")";



			// IR Function must be enabled seperately
			// use try/catch block to raise your own error message when IoWarrior does not support IR
			try 
			{
				iow.EnableIR();
			}
			catch (Exception exc)
			{
				MessageBox.Show( exc.Message, "IR not available", MessageBoxButtons.OK, MessageBoxIcon.Warning );
			}

			// In order to fetch the IR Messages, you have to make your own Event
			// this is simply done by this line: (the parameter at IrEventHandler is your Event function Name)
			iow.OnIREvent += new IOWKit.IREventHandler( MyOnIREvent );

		}

		/// <summary>
		/// This function is called when the IR receives some data.
		/// Hint: you have to use "IREventArgs", which is derived from System.EventArgs
		/// </summary>
		private void MyOnIREvent(object sender, IREventArgs e)
		{
			lbIRMessages.Items.Insert(0,  "RC5 deviceNr: " + e.remoteControlID + " - key: " + e.keyPressed + " - toggle: " + e.toggleBit);
			if( e.keyPressed == 12) // power off
				Org.Mentalis.Utilities.WindowsController.ExitWindows( Org.Mentalis.Utilities.RestartOptions.PowerOff, true);
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			QuitAll(sender, e);
		}

		/// <summary>
		/// ends all functionality
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void QuitAll(object sender, System.EventArgs e)
		{
			this.Hide();
			iow.DisableIR(); // disables the IR function. iow.Quit() will call this function too, so you can skip this step if you want.
			iow.Quit(); // turns LCD Off, stops all relevant threads and disables the IR function if it is still enabled.
			notifyIcon1.Visible = false; // prevent windows bug - icon could still be displayed 
			Application.Exit(); 
			Environment.Exit(0); // be sure to quit all threads which could be still open
			
		}

		private void TextBoxEnter(object sender, System.EventArgs e)
		{
			if(lastActiveTB != null)
				lastActiveTB.BackColor = SystemColors.Window;

			lastActiveTB = (TextBox)sender;
			lastActiveTB.BackColor = SystemColors.Info;
		}

		private void alignLeftBtn_Click(object sender, System.EventArgs e)
		{
			if( lastActiveTB == null )
				return;
			iow.WriteLine( lastActiveTB.TabIndex, lastActiveTB.Text, IOWKit.AlignType.Left);
			lastActiveTB.TextAlign = HorizontalAlignment.Left;

		}

		private void alignCenterBtn_Click(object sender, System.EventArgs e)
		{
			if( lastActiveTB == null )
				return;
			iow.WriteLine( lastActiveTB.TabIndex, lastActiveTB.Text, IOWKit.AlignType.Center);
			lastActiveTB.TextAlign = HorizontalAlignment.Center;
		}

		private void alignRightBtn_Click(object sender, System.EventArgs e)
		{
			if( lastActiveTB == null )
				return;
			iow.WriteLine( lastActiveTB.TabIndex, lastActiveTB.Text, IOWKit.AlignType.Right);
			lastActiveTB.TextAlign = HorizontalAlignment.Right;
		}

		private void clrLineBtn_Click(object sender, System.EventArgs e)
		{
			if( lastActiveTB == null )
				return;
			iow.ClearLine( lastActiveTB.TabIndex) ;
		}

		private void clrLcdBtn_Click(object sender, System.EventArgs e)
		{
			iow.ClearScreen();
		}

		private void cbUseIR_CheckedChanged(object sender, System.EventArgs e)
		{
			if(cbUseIR.Checked)
			{
				iow.EnableIR();
				lbIRMessages.Enabled = true;
			}
			else
			{
				iow.DisableIR();
				lbIRMessages.Enabled = false;
			}
		}

		private void cbCursorsOptions_CheckedChanged(object sender, System.EventArgs e)
		{
			iow.SetCursorMode( cbShowCursor.Checked, cbCursorBlinking.Checked);
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			if( this.cbCharAddress.SelectedIndex < 0)
			{
				MessageBox.Show("Please select the adress for this special char!", null, MessageBoxButtons.OK, MessageBoxIcon.Warning);
				return;
			}

			bool[][] dotMatrixBool = new bool[5][];
			
			for(int i = 0; i < 5; i++)
				dotMatrixBool[i] = new bool[8];

			for(int i = 0; i < 5; i++)
				for(int j = 0; j < 8; j++)
					dotMatrixBool[i][j] = this.dotMatrixTB[i][j].Selected;
			
			if(iow.UploadSpecialChar(this.cbCharAddress.SelectedIndex, dotMatrixBool))
				MessageBox.Show("Character successfully uploaded", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information);
			else
				MessageBox.Show("Could not upload character", null, MessageBoxButtons.OK, MessageBoxIcon.Error);

		}

		#region this code will be available in future releases and is just for testing the possibilites for showing some status information
/*
		public System.Threading.Thread t;

		private void button2_Click(object sender, System.EventArgs e)
		{
			t = new System.Threading.Thread( new System.Threading.ThreadStart( ShowStats ));
			t.Start();
			t.IsBackground = true;
		}

		private void ShowStats()
		{
			PerformanceCounter cpuC = new PerformanceCounter("Processor", "% Processor Time", true);
			PerformanceCounter memC = new PerformanceCounter("Speicher", "Zugesicherte Bytes", true);
			PerformanceCounter ninC = new PerformanceCounter("Netzwerkschnittstelle", "Empfangene Bytes/s", true);
			PerformanceCounter nouC = new PerformanceCounter("Netzwerkschnittstelle", "Bytes gesendet/s", true);

			cpuC.InstanceName = "_Total";
			ninC.InstanceName = "NVIDIA nForce MCP Networking Adapter - Paketplaner-Miniport";
			nouC.InstanceName = "NVIDIA nForce MCP Networking Adapter - Paketplaner-Miniport";

			while ( iow.LCDEnabled ) 
			{
				String cpu = String.Format("CPU: {0:0#} %", (int)cpuC.NextValue());
				iow.WriteLine(1, cpu);
			
				String mem = String.Format("MEM: {0:0#} MB", (int)memC.NextValue() / 1024 / 1024);
				iow.WriteLine(2, mem);

				String inn = String.Format("IN:  {0:0.00} kb/sec", ninC.NextValue() / 1024);
				iow.WriteLine(3, inn);

				String oun = String.Format("OUT: {0:0.00} kb/sec", ninC.NextValue() / 1024);
				iow.WriteLine(4, oun);
	
				//DateTime today = DateTime.Now;
				//iow.WriteLine(4, "TIME: " + today.TimeOfDay.Hours + ":" + today.TimeOfDay.Minutes + ":" + today.TimeOfDay.Seconds);

				System.Threading.Thread.Sleep(1000);
			}

		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			Org.Mentalis.Utilities.WindowsController.ExitWindows( Org.Mentalis.Utilities.RestartOptions.PowerOff, true);
			
			
		}
*/
		#endregion
	}
}
